annotate sbin/fjail @ 286:258a1dfd52eb

Separate manual page documentation and "normal" HTML documentation. No "orphaned" source files should be there now. Also the HTML theme for the is changed from "alabaster" to "agogo".
author Franz Glasner <fzglas.hg@dom66.de>
date Sun, 18 Sep 2022 10:25:55 +0200
parents 3c24b07240f2
children 90fa5b68bb62
Ignore whitespace changes - Everywhere: Within whitespace: At end of lines:
rev   line source
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
1 #!/bin/sh
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
2 # -*- indent-tabs-mode: nil; -*-
86
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
3 : 'A very minimal BSD Jail management tool.
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
4
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
5 :Author: Franz Glasner
193
62a24dfb238c Adjust copyright year
Franz Glasner <fzglas.hg@dom66.de>
parents: 184
diff changeset
6 :Copyright: (c) 2019-2022 Franz Glasner.
86
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
7 All rights reserved.
104
6f6058939e48 Use the "Full name" in the license section for "fjail" also
Franz Glasner <fzglas.hg@dom66.de>
parents: 93
diff changeset
8 :License: BSD 3-Clause "New" or "Revised" License.
86
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
9 See LICENSE for details.
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
10 If you cannot find LICENSE see
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
11 <https://opensource.org/licenses/BSD-3-Clause>
93
c95726f83f84 Style: :Id: -> :ID:
Franz Glasner <fzglas.hg@dom66.de>
parents: 92
diff changeset
12 :ID: @(#)@@PKGORIGIN@@ $HGid$
86
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
13
a3b9d4fe560e Provide "module" doc-strings
Franz Glasner <fzglas.hg@dom66.de>
parents: 85
diff changeset
14 '
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
15
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
16 set -eu
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
17
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
18 VERSION="@@VERSION@@"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
19
105
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
20 USAGE='
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
21 USAGE: fjail [ OPTIONS ] COMMAND [ COMMAND OPTIONS ] [ ARG ... ]
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
22
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
23 OPTIONS:
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
24
81
124faa20ae80 Implemented a "-V" global option to print the program's name and version number to stdout
Franz Glasner <fzglas.hg@dom66.de>
parents: 80
diff changeset
25 -V Print the program name and version number to stdout and exit
124faa20ae80 Implemented a "-V" global option to print the program's name and version number to stdout
Franz Glasner <fzglas.hg@dom66.de>
parents: 80
diff changeset
26
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
27 -h Print this help message to stdout and exit
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
28
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
29 COMMANDS:
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
30
205
fcfa674c8444 FIX: in the help message: improve documentation of OPTIONS
Franz Glasner <fzglas.hg@dom66.de>
parents: 204
diff changeset
31 datasets [OPTIONS] PARENT CHILD
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
32
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
33 Create ZFS datasets to be used within a jail
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
34
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
35 PARENT must exist already and CHILD must not exist.
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
36
255
7f21d242f79f FIX: Description of "-A"
Franz Glasner <fzglas.hg@dom66.de>
parents: 250
diff changeset
37 -A Set "canmount=noauto" for datasets
211
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
38 -o Do not create var/empty as read-only dataset but with normal settings
177
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
39 -s Also create a dataset for freebsd-update data files
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
40 -t Create a more tiny set of datasets
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
41 -T Create only an extra tiny set of datasets
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
42 -u Do not automatically mount newly created datasets
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
43
276
3c24b07240f2 Move the implementation of "mount" and "umount" into the new tool fzfs.
Franz Glasner <fzglas.hg@dom66.de>
parents: 265
diff changeset
44 mount
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
45
276
3c24b07240f2 Move the implementation of "mount" and "umount" into the new tool fzfs.
Franz Glasner <fzglas.hg@dom66.de>
parents: 265
diff changeset
46 See sibling tool `fzfs'"'"'
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
47
276
3c24b07240f2 Move the implementation of "mount" and "umount" into the new tool fzfs.
Franz Glasner <fzglas.hg@dom66.de>
parents: 265
diff changeset
48 umount
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
49
276
3c24b07240f2 Move the implementation of "mount" and "umount" into the new tool fzfs.
Franz Glasner <fzglas.hg@dom66.de>
parents: 265
diff changeset
50 See sibling tool `fzfs'"'"'
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
51
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
52 privs MOUNTPOINT
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
53
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
54 Adjust some Unix privileges to mounted jail datasets
76
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
55
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
56 populate MOUNTPOINT BASETXZ
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
57
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
58 Populate the jail directory in MOUNTPOINT with the base system in BASETXZ
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
59
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
60 configure MOUNPOINT
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
61
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
62 Configure some basic parts of the system at MOUNTPOINT:
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
63 disable root password, syslog and other basic configuration settings
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
64
250
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
65 Also handle thin jails by checking whether "etc" is a symlink to
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
66 "skeleton/etc".
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
67
226
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
68 hostid
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
69
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
70 Print proposals for a hostuuid and hostid
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
71
205
fcfa674c8444 FIX: in the help message: improve documentation of OPTIONS
Franz Glasner <fzglas.hg@dom66.de>
parents: 204
diff changeset
72 copy [OPTIONS] SOURCE-DATASET DEST-DATASET
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
73
105
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
74 Copy a tree of ZFS datasets with "zfs send -R" and "zfs receive".
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
75 Note that the destination dataset must not exist already.
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
76
178
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
77 -r Copy the datasets with the -Lec options (aka "raw")
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
78 -u Do not automatically mount received datasets
105
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
79
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
80 ENVIRONMENT:
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
81
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
82 All environment variables that affect "zfs" are effective also.
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
83
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
84 DESCRIPTION:
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
85
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
86 All commands with the exception of "populate" require ZFS as
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
87 filesystem.
52523a19797e Docu: Enhance the docu of fjail
Franz Glasner <fzglas.hg@dom66.de>
parents: 104
diff changeset
88 '
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
89
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
90
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
91 # Reset to standard umask
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
92 umask 0022
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
93
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
94
161
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
95 _get_dataset_for_mountpoint() {
196
a4fd3bcbbf1c Use "mount -p" instead of "zfs mount" when determining devices for the real mountpoints
Franz Glasner <fzglas.hg@dom66.de>
parents: 195
diff changeset
96 : 'Use `mount -t zfs -p` to determine the ZFS dataset for a given mountpoint.
161
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
97
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
98 '
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
99 local _mountpoint
196
a4fd3bcbbf1c Use "mount -p" instead of "zfs mount" when determining devices for the real mountpoints
Franz Glasner <fzglas.hg@dom66.de>
parents: 195
diff changeset
100 local _ds _mount _rest
161
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
101
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
102 _mountpoint="$1"
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
103
197
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
104 mount -t zfs -p \
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
105 | {
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
106 while IFS=' '$'\t' read -r _ds _mount _rest ; do
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
107 if [ "$_mount" = "$_mountpoint" ]; then
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
108 echo "${_ds}"
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
109 return 0
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
110 fi
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
111 done
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
112 return 1
3181a6b5758e FIX: Using a pipeline within a function correctly with regard to return values:
Franz Glasner <fzglas.hg@dom66.de>
parents: 196
diff changeset
113 }
161
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
114 }
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
115
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
116
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
117 _get_dataset_for_varempty() {
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
118 : 'Allow special handling for <mountpoint>/var/empty which may be
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
119 mounted read-only.
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
120
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
121 '
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
122 local _mountpoint
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
123 local _ve_mount
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
124
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
125 _mountpoint="$1"
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
126
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
127 if [ "$_mountpoint" = '/' ]; then
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
128 _ve_mount='/var/empty'
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
129 else
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
130 _ve_mount="${_mountpoint}/var/empty"
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
131 fi
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
132
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
133 _get_dataset_for_mountpoint "${_ve_mount}"
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
134 }
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
135
57b9b899bf77 Provide functions that will be the base for "/var/empty" handling (manipulate the "readonly" property when doing some special operations)
Franz Glasner <fzglas.hg@dom66.de>
parents: 157
diff changeset
136
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
137 #
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
138 # "datasets" -- create the ZFS dataset tree
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
139 #
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
140 # command_datasets [ -u ] parent-dataset child-dataset
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
141 #
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
142 # -u do not automatically mount newly created datasets
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
143 #
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
144 command_datasets() {
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
145 # parent ZFS dataset -- child ZFS dataset name
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
146 local _pds _cds
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
147 # and its mount point
202
6b7a084ddf1d Replace all calls to "zfs get" to "zfs list -o".
Franz Glasner <fzglas.hg@dom66.de>
parents: 201
diff changeset
148 local _pmp _get
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
149 # full name of the dataset
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
150 local _ds
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
151 # dynamic ZFS options -- create cache for freebsd-update -- use a more tiny layout
211
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
152 local _zfsopts _fbsdupdate _tiny _zfsnoauto _varempty_ro
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
153
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
154 _zfsopts=""
177
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
155 _fbsdupdate=""
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
156 _tiny="no"
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
157 _zfsnoauto=""
211
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
158 _varempty_ro="-o readonly=on"
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
159 while getopts "oustAT" _opt ; do
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
160 case ${_opt} in
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
161 A)
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
162 #
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
163 # set canmount=noauto where otherwise canmount=on would have been set
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
164 # or inherited
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
165 #
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
166 _zfsnoauto="-o canmount=noauto"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
167 ;;
211
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
168 o)
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
169 # Clear out the default setting of creating var/empty as read-only dataset
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
170 _varempty_ro=""
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
171 ;;
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
172 t)
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
173 # use a more tiny layout
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
174 _tiny="yes"
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
175 ;;
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
176 T) # extra tiny layout
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
177 _tiny="extra"
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
178 ;;
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
179 u)
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
180 # do not mount newly created datasets
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
181 _zfsopts="${_zfsopts} -u"
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
182 ;;
177
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
183 s)
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
184 # create also a dataset for freebsd-update data
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
185 _fbsdupdate="yes"
179
6c144aca8ac5 FIX: Proper case-switch termination
Franz Glasner <hg@dom66.de>
parents: 178
diff changeset
186 ;;
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
187 \?|:)
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
188 return 2;
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
189 ;;
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
190 esac
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
191 done
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
192 shift $((OPTIND-1))
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
193 OPTIND=1
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
194
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
195 _pds="$1"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
196 if [ -z "${_pds}" ]; then
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
197 echo "ERROR: no parent dataset given" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
198 return 2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
199 fi
203
eb95c986cc59 Use -t filesystem in all "zfs list" calls
Franz Glasner <fzglas.hg@dom66.de>
parents: 202
diff changeset
200 _pmp=$(zfs list -H -o mountpoint -t filesystem "${_pds}" 2>/dev/null) || { echo "ERROR: dataset \`${_pds}' does not exist" >&2; return 1; }
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
201 case "${_pmp}" in
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
202 none)
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
203 echo "ERROR: dataset \`${_pds}' has no mountpoint" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
204 return 1
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
205 ;;
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
206 legacy)
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
207 echo "ERROR: dataset \`${_pds}' has a \`${_mp}' mountpoint" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
208 return 1
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
209 ;;
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
210 *)
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
211 # VOID
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
212 ;;
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
213 esac
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
214 _cds="$2"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
215 if [ -z "${_cds}" ]; then
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
216 echo "ERROR: no child dataset given" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
217 return 2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
218 fi
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
219 _ds="${_pds}/${_cds}"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
220 echo "Resulting new root dataset is \`${_ds}' at mountpoint \`${_pmp}/${_cds}'"
203
eb95c986cc59 Use -t filesystem in all "zfs list" calls
Franz Glasner <fzglas.hg@dom66.de>
parents: 202
diff changeset
221 if zfs list -H -o mountpoint -t filesystem "${_ds}" >/dev/null 2>/dev/null; then
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
222 echo "ERROR: dataset \`${_ds}' does already exist" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
223 return 1
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
224 fi
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
225
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
226 #
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
227 # NOTE: For BEs these directory will be *excluded* from the BE
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
228 #
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
229 # /tmp
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
230 # /usr/home
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
231 # /usr/ports
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
232 # /usr/src
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
233 # /var/audit
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
234 # /var/crash
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
235 # /var/log
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
236 # /var/mail
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
237 # /var/tmp
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
238 #
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
239 zfs create ${_zfsopts} ${_zfsnoauto} -o atime=off "${_ds}"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
240 zfs create ${_zfsopts} ${_zfsnoauto} -o sync=disabled -o setuid=off "${_ds}/tmp"
182
dbd62c32b3fd FIX: Do expansion then comparing
Franz Glasner <hg@dom66.de>
parents: 181
diff changeset
241 if [ "${_tiny}" != "extra" ]; then
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
242 if [ "${_tiny}" = "yes" ]; then
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
243 zfs create ${_zfsopts} -o canmount=off "${_ds}/usr"
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
244 else
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
245 zfs create ${_zfsopts} ${_zfsnoauto} "${_ds}/usr"
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
246 fi
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
247 zfs create ${_zfsopts} ${_zfsnoauto} -o setuid=off "${_ds}/usr/home"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
248 zfs create ${_zfsopts} ${_zfsnoauto} "${_ds}/usr/local"
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
249 fi
182
dbd62c32b3fd FIX: Do expansion then comparing
Franz Glasner <hg@dom66.de>
parents: 181
diff changeset
250 if [ \( "${_tiny}" = "yes" \) -o \( "${_tiny}" = "extra" \) ]; then
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
251 zfs create ${_zfsopts} -o canmount=off "${_ds}/var"
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
252 else
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
253 zfs create ${_zfsopts} ${_zfsnoauto} "${_ds}/var"
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
254 fi
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
255 if [ "${_tiny}" != "extra" ]; then
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
256 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off "${_ds}/var/audit"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
257 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off "${_ds}/var/cache"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
258 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off -o primarycache=metadata -o compression=off "${_ds}/var/cache/pkg"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
259 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off -o compression=off "${_ds}/var/crash"
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
260 fi
177
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
261 if [ "$_fbsdupdate" = "yes" ]; then
182
dbd62c32b3fd FIX: Do expansion then comparing
Franz Glasner <hg@dom66.de>
parents: 181
diff changeset
262 if [ \( "${_tiny}" = "yes" \) -o \( "${_tiny}" = "extra" \) ]; then
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
263 zfs create ${_zfsopts} -o canmount=off -o exec=off -o setuid=off "${_ds}/var/db"
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
264 else
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
265 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off "${_ds}/var/db"
181
d30a68e66d60 More dataset creation options: -t (tiny) and -T (extra tiny)
Franz Glasner <hg@dom66.de>
parents: 180
diff changeset
266 fi
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
267 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off -o primarycache=metadata -o compression=off "${_ds}/var/db/freebsd-update"
177
9ffbe53dbc35 Flag for creating a separatate dataset for freebsd-update data.
Franz Glasner <hg@dom66.de>
parents: 176
diff changeset
268 fi
211
ee9b32ab0e9a Implement the "-o" option for "datasets" to create var/empty with the default "readonly" setting instead of "readonly=on"
Franz Glasner <fzglas.hg@dom66.de>
parents: 210
diff changeset
269 zfs create ${_zfsopts} ${_zfsnoauto} ${_varempty_ro} -o exec=off -o setuid=off "${_ds}/var/empty"
204
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
270 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off -o primarycache=metadata "${_ds}/var/log"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
271 zfs create ${_zfsopts} ${_zfsnoauto} -o exec=off -o setuid=off -o atime=on "${_ds}/var/mail"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
272 zfs create ${_zfsopts} ${_zfsnoauto} -o sync=disabled -o exec=off -o setuid=off -o compression=off -o primarycache=all "${_ds}/var/run"
ef397b84b047 Implement a "-A" flat for dataset creation: set canmount=noauto
Franz Glasner <fzglas.hg@dom66.de>
parents: 203
diff changeset
273 zfs create ${_zfsopts} ${_zfsnoauto} -o sync=disabled -o setuid=off "${_ds}/var/tmp"
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
274 }
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
275
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
276
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
277 #
76
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
278 # "populate" -- populate the datasets with content from a FreeBSD base.txz
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
279 #
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
280 # command_populate mountpoint basetxz
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
281 #
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
282 command_populate() {
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
283 # MOUNTPOINT -- base.txz
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
284 local _mp _basetxz
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
285
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
286 _mp="$1"
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
287 _basetxz="$2"
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
288
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
289 if [ -z "${_mp}" ]; then
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
290 echo "ERROR: no mountpoint given" >&2
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
291 return 2
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
292 fi
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
293 if [ -z "${_basetxz}" ]; then
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
294 echo "ERROR: no base.txz given" >&2
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
295 return 2
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
296 fi
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
297 if [ ! -d "${_mp}" ]; then
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
298 echo "ERROR: mountpoint \`${_mp}' does not exist" >&2
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
299 return 1
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
300 fi
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
301 if [ ! -r "${_basetxz}" ]; then
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
302 echo "ERROR: file \`${_basetxz}' is not readable" >&2
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
303 return 1
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
304 fi
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
305
173
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
306 #
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
307 # Handle /var/empty separately later: could be already there and
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
308 # mounted read-only.
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
309 #
164
b62b8bc6184f Because of mtree errors in freebsd-update: let the directory tree in /boot stay as expanded but delete all regular files
Franz Glasner <hg@dom66.de>
parents: 163
diff changeset
310 tar -C "${_mp}" --exclude=./var/empty -xJp -f "${_basetxz}" || { echo "ERROR: tar encountered errors" >&2; return 1; }
173
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
311 if [ -d "${_mp}/var/empty" ]; then
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
312 #
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
313 # If /var/empty exists already try to extract with changing the
183
ea491007d7fb FIX: Because of set -eu: ignore errors from tar explicitely
Franz Glasner <hg@dom66.de>
parents: 182
diff changeset
314 # flags (e.g. `schg'). But be ignore errors here.
173
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
315 #
184
2e7d0c967c36 Print a message when tar errors regaring ./var/empty are ignored
Franz Glasner <hg@dom66.de>
parents: 183
diff changeset
316 tar -C "${_mp}" -xJp -f "${_basetxz}" ./var/empty || { echo "tar warnings for handling ./var/empty ignored because ./var/empty exists already" >&2; }
173
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
317 else
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
318 # Just extract /var/empty normally
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
319 tar -C "${_mp}" -xJp -f "${_basetxz}" ./var/empty || { echo "ERROR: tar encountered errors" >&2; return 1; }
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
320 fi
6782ac823f86 Handle /var/empty more sanely when populating datasets from a base.txz image
Franz Glasner <fzglas.hg@dom66.de>
parents: 164
diff changeset
321
164
b62b8bc6184f Because of mtree errors in freebsd-update: let the directory tree in /boot stay as expanded but delete all regular files
Franz Glasner <hg@dom66.de>
parents: 163
diff changeset
322 find "${_mp}/boot" -type f -delete
76
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
323 }
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
324
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
325
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
326 #
226
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
327 # "hostid" -- print a proposal for hostid/hostuuid settings in a jail
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
328 #
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
329 # command_hostid
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
330 #
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
331 command_hostid() {
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
332 #
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
333 # hostid and hostuuid should be set (at least for consistency ressons)
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
334 # in vnet jails (see /etc/rc.d/hostid and /etc/rc.d/hostid_save).
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
335 # They can be set in the jail.conf.
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
336 # Print one here that can be pasted into the jail.conf if needed.
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
337 #
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
338 # hostid and hostuuid for non-vnet jails are inherited from the parent/host.
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
339 #
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
340 # See also /etc/rc.d/hostid and /etc/rc.d/hostid_save.
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
341 #
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
342 local _new_hostuuid _new_hostid
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
343 _new_hostuuid="$(uuidgen)"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
344 _new_hostid="$(echo -n ${_new_hostuuid} | /sbin/md5)"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
345 _new_hostid="0x${_new_hostid%%????????????????????????}"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
346
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
347 echo "Proposed hostuuid/hostid:"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
348 echo " host.hostuuid = \"${_new_hostuuid}\";"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
349 echo " host.hostid = $((_new_hostid));"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
350 #echo " host.hostid = ${_new_hostid};"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
351 }
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
352
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
353
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
354 #
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
355 # "configure" -- configure the mountpoint
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
356 #
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
357 # command_configure mountpoint
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
358 #
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
359 command_configure() {
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
360 # mountpoint
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
361 local _mp
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
362
228
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
363 local _pcl
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
364
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
365 _mp="$1"
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
366
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
367 if [ -z "${_mp}" ]; then
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
368 echo "ERROR: no mountpoint given" >&2
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
369 return 2
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
370 fi
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
371 if [ ! -d "${_mp}" ]; then
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
372 echo "ERROR: mountpoint \`${_mp}' does not exist" >&2
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
373 return 1
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
374 fi
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
375
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
376 # Deactive the by default empty root password
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
377 pw -R "${_mp}" usermod -w no -n root
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
378
229
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
379 if [ -f "${_mp}/etc/defaults/rc.conf" ]; then
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
380
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
381 sysrc -R "${_mp}" sendmail_enable=NONE
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
382 sysrc -R "${_mp}" clear_tmp_enable=YES
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
383 sysrc -R "${_mp}" clear_tmp_X=NO
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
384 sysrc -R "${_mp}" syslogd_flags=-ss
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
385 sysrc -R "${_mp}" bsdstats_enable=NO # no automatic BSD stats when booting
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
386 else
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
387 echo "WARNING: No \"${_mp}/etc/defaults/rc.conf\": not configuring \"rc.conf\""
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
388 fi
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
389
229
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
390 if [ -f "${_mp}/usr/share/zoneinfo/Europe/Berlin" ]; then
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
391 # Timezone to CET
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
392 if [ ! -f "${_mp}/etc/localtime" ]; then
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
393 echo "Setting timezone to Europe/Berlin"
250
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
394 # Handle thin jails automatically (but check expectations very strictly)
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
395 if [ \( -L "${_mp}/etc" \) -a \( "$(readlink "${_mp}/etc")" = "skeleton/etc" \) ]; then
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
396 ln -s ../../usr/share/zoneinfo/Europe/Berlin "${_mp}/etc/localtime"
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
397 else
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
398 ln -s ../usr/share/zoneinfo/Europe/Berlin "${_mp}/etc/localtime"
c4d835ccb4ae Implement configure for symlinked skeletons.
Franz Glasner <fzglas.hg@dom66.de>
parents: 229
diff changeset
399 fi
229
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
400 echo "Europe/Berlin" > "${_mp}/var/db/zoneinfo"
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
401 else
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
402 echo "WARNING: \"${_mp}/etc/localtime\" exists already -- not changed"
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
403 fi
222
16238e9032a9 Skip configuring a timezone when there already exists such a file /etc/localtime
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 221
diff changeset
404 else
229
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
405 echo "WARNING: No timezone data file found at \"${_mp}/usr/share/zoneinfo/Europe/Berlin\": skipping timezone setup"
222
16238e9032a9 Skip configuring a timezone when there already exists such a file /etc/localtime
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 221
diff changeset
406 fi
221
f62f8ec6a19b Mark a todo for setting a "hostid"
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 220
diff changeset
407
224
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
408 # resolv.conf
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
409 if [ ! -f "${_mp}/etc/resolv.conf" ]; then
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
410 echo "Copying the host's resolv.conf into the jail"
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
411 cp -p /etc/resolv.conf "${_mp}/etc/resolv.conf"
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
412 else
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
413 echo "WARNING: \"${_mp}/etc/resolv.conf\" exists already -- not changed"
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
414 fi
6713d97b4180 Copy the host's resolv.conf into a jail when configuring it.
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 223
diff changeset
415
225
ffd24013d346 When configuring a jail also call "newaliases" within the jail
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 224
diff changeset
416 # Call newaliases within the jail
227
a7a9fd895d30 Print message when calling "newaliases"
Franz Glasner <fzglas.hg@dom66.de>
parents: 226
diff changeset
417 echo "Calling \"newaliases\""
225
ffd24013d346 When configuring a jail also call "newaliases" within the jail
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 224
diff changeset
418 chroot "${_mp}" /usr/bin/newaliases
ffd24013d346 When configuring a jail also call "newaliases" within the jail
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 224
diff changeset
419
228
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
420 _pcl="${_mp}/etc/periodic.conf.local"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
421 if [ ! -f "${_pcl}" ]; then
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
422 echo "Adjusting periodic.conf.local"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
423 echo "daily_ntpd_leapfile_enable=\"NO\"" > "${_pcl}"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
424 echo "daily_status_zfs_zpool_list_enable=\"NO\"" >> "${_pcl}"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
425 echo "daily_status_disks_enable=\"NO\"" >> "${_pcl}"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
426 echo "daily_status_uptime_enable=\"NO\"" >> "${_pcl}"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
427
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
428 echo "security_status_chkmounts_enable=\"NO\"" >> "${_pcl}"
229
243dba574ad3 More sanity checks when configuring jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 228
diff changeset
429
228
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
430 else
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
431 echo "WARNING: \"${_pcl}\" exists already -- not changed"
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
432 fi
4493e364cabf Also configure periodic when configuring a jail
Franz Glasner <fzglas.hg@dom66.de>
parents: 227
diff changeset
433
226
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
434 command_hostid
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
435 }
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
436
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
437
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
438 #
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
439 # "copy" -- ZFS copy of datasets
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
440 #
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
441 # command_copy source-dataset destination-dataset
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
442 #
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
443 command_copy() {
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
444 # source dataset -- destination dataset
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
445 local _source _dest
178
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
446 # dynamic ZFS options -- ZFS copy options
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
447 local _zfsopts _zfscopyopts
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
448
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
449 _zfsopts=""
178
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
450 _zfscopyopts=""
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
451 while getopts "ru" _opt ; do
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
452 case ${_opt} in
178
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
453 r)
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
454 # Use raw datasets
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
455 _zfscopyopts="-Lec"
179
6c144aca8ac5 FIX: Proper case-switch termination
Franz Glasner <hg@dom66.de>
parents: 178
diff changeset
456 ;;
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
457 u)
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
458 # do not mount newly created datasets
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
459 _zfsopts="${_zfsopts} -u"
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
460 ;;
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
461 \?|:)
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
462 return 2;
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
463 ;;
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
464 esac
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
465 done
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
466 shift $((OPTIND-1))
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
467 OPTIND=1
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
468
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
469 _source="$1"
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
470 if [ -z "${_source}" ]; then
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
471 echo "ERROR: no source dataset given" >&2
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
472 return 2
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
473 fi
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
474 _dest="$2"
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
475 if [ -z "${_dest}" ]; then
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
476 echo "ERROR: no source dataset given" >&2
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
477 return 2
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
478 fi
178
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
479 zfs send -R ${_zfscopyopts} -n -v "${_source}" || { echo "ERROR: ZFS operation failed in no-op mode" >&2; return 1; }
00fbf2b4b44f Allow to copy ZFS datasets in "raw" mode (with "-Lec" set)
Franz Glasner <hg@dom66.de>
parents: 177
diff changeset
480 zfs send -R ${_zfscopyopts} "${_source}" | zfs receive ${_zfsopts} "${_dest}" || { echo "ERROR: ZFS operation failed" >&2; return 1; }
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
481 }
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
482
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
483
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
484 #
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
485 # "privs" -- adjust privileges
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
486 #
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
487 # To be used when all ZFS datasets are mounted.
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
488 #
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
489 command_privs() {
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
490 # mountpoint
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
491 local _mp _d _veds _get _vestatus
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
492
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
493 _mp="$1"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
494 if [ -z "${_mp}" ]; then
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
495 echo "ERROR: no mountpoint given" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
496 return 2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
497 fi
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
498 if [ ! -d "${_mp}" ]; then
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
499 echo "ERROR: directory \`${_mp}' does not exist" >&2
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
500 return 1
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
501 fi
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
502 for _d in tmp var/tmp ; do
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
503 chmod 01777 "${_mp}/${_d}"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
504 done
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
505 chown root:mail "${_mp}/var/mail"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
506 chmod 0775 "${_mp}/var/mail"
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
507
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
508 #
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
509 # Handle <mountpoint>/var/empty specially:
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
510 # make it writeable temporarily if it is mounted read-only:
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
511 #
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
512 _vestatus=""
196
a4fd3bcbbf1c Use "mount -p" instead of "zfs mount" when determining devices for the real mountpoints
Franz Glasner <fzglas.hg@dom66.de>
parents: 195
diff changeset
513 _veds="$(_get_dataset_for_varempty "${_mp}")"
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
514 if [ $? -eq 0 ]; then
203
eb95c986cc59 Use -t filesystem in all "zfs list" calls
Franz Glasner <fzglas.hg@dom66.de>
parents: 202
diff changeset
515 _vestatus=$(zfs list -H -o readonly -t filesystem ${_veds} 2>/dev/null) || { echo "ERROR: cannot determine readonly status of ${_mp}/var/empty" >&2; return 1; }
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
516 if [ "${_vestatus}" = "on" ]; then
199
a8b6584d24ec FIX: Do not suppress stderr messages from some "zfs set" calls.
Franz Glasner <fzglas.hg@dom66.de>
parents: 198
diff changeset
517 zfs set readonly=off ${_veds} 1> /dev/null || { echo "ERROR: cannot reset readonly-status of ${_mp}/var/empty" >&2; return 1; }
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
518 fi
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
519 fi
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
520 # Set the access rights and the file flags as given in mtree
198
dd8a9bbdf8c0 Better error handling when changing privileges and flags of var/empty
Franz Glasner <fzglas.hg@dom66.de>
parents: 197
diff changeset
521 chmod 0555 "${_mp}/var/empty" || { echo "WARNING: Cannot chmod on var/empty" >&2; }
dd8a9bbdf8c0 Better error handling when changing privileges and flags of var/empty
Franz Glasner <fzglas.hg@dom66.de>
parents: 197
diff changeset
522 chflags schg "${_mp}/var/empty" || { echo "WARNING: Cannot chflags on var/empty" >&2; }
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
523 # Reset the read-only status of the mountpoint as it was before
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
524 if [ "${_vestatus}" = "on" ]; then
199
a8b6584d24ec FIX: Do not suppress stderr messages from some "zfs set" calls.
Franz Glasner <fzglas.hg@dom66.de>
parents: 198
diff changeset
525 zfs set readonly=on ${_veds} 1> /dev/null || { echo "ERROR: cannot reactivate readonly-status of ${_mp}/var/empty" >&2; return 1; }
162
9bd38c55a75c When executing the "privs" command try to make <mountpoint>/var/empty writeable temporarily to set proper permissions and file flags
Franz Glasner <hg@dom66.de>
parents: 161
diff changeset
526 fi
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
527 }
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
528
74
247d35f910ca fjail datasets now recognized a "-u" command option to not automatically mount created datasets
Franz Glasner <hg@dom66.de>
parents: 73
diff changeset
529
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
530 #
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
531 # Global option handling
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
532 #
81
124faa20ae80 Implemented a "-V" global option to print the program's name and version number to stdout
Franz Glasner <fzglas.hg@dom66.de>
parents: 80
diff changeset
533 while getopts "Vh" _opt ; do
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
534 case ${_opt} in
81
124faa20ae80 Implemented a "-V" global option to print the program's name and version number to stdout
Franz Glasner <fzglas.hg@dom66.de>
parents: 80
diff changeset
535 V)
144
6be3742d21f7 - FIX: Really print the version in check-ports
Franz Glasner <hg@dom66.de>
parents: 128
diff changeset
536 printf 'fjail v%s (rv:%s)\n' "${VERSION}" '@@HGREVISION@@'
81
124faa20ae80 Implemented a "-V" global option to print the program's name and version number to stdout
Franz Glasner <fzglas.hg@dom66.de>
parents: 80
diff changeset
537 exit 0
124faa20ae80 Implemented a "-V" global option to print the program's name and version number to stdout
Franz Glasner <fzglas.hg@dom66.de>
parents: 80
diff changeset
538 ;;
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
539 h)
75
2e3ac70bdfc8 A fairly usable usage message
Franz Glasner <hg@dom66.de>
parents: 74
diff changeset
540 echo "${USAGE}"
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
541 exit 0
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
542 ;;
80
f5cf08e8d246 Handle the error case when option handling fails because of wrong case labels
Franz Glasner <fzglas.hg@dom66.de>
parents: 77
diff changeset
543 \?)
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
544 exit 2;
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
545 ;;
80
f5cf08e8d246 Handle the error case when option handling fails because of wrong case labels
Franz Glasner <fzglas.hg@dom66.de>
parents: 77
diff changeset
546 *)
f5cf08e8d246 Handle the error case when option handling fails because of wrong case labels
Franz Glasner <fzglas.hg@dom66.de>
parents: 77
diff changeset
547 echo "ERROR: option handling failed" >&2
f5cf08e8d246 Handle the error case when option handling fails because of wrong case labels
Franz Glasner <fzglas.hg@dom66.de>
parents: 77
diff changeset
548 exit 2
f5cf08e8d246 Handle the error case when option handling fails because of wrong case labels
Franz Glasner <fzglas.hg@dom66.de>
parents: 77
diff changeset
549 ;;
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
550 esac
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
551 done
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
552
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
553 #
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
554 # Reset the Shell's option handling system to prepare for handling
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
555 # command-local options.
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
556 #
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
557 shift $((OPTIND-1))
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
558 OPTIND=1
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
559
92
a8e76893140f Extra error message if no command is given
Franz Glasner <fzglas.hg@dom66.de>
parents: 86
diff changeset
560 test $# -gt 0 || { echo "ERROR: no command given" >&2; exit 2; }
a8e76893140f Extra error message if no command is given
Franz Glasner <fzglas.hg@dom66.de>
parents: 86
diff changeset
561
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
562 command="$1"
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
563 shift
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
564
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
565 case "${command}" in
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
566 datasets)
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
567 command_datasets "$@"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
568 ;;
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
569 mount)
276
3c24b07240f2 Move the implementation of "mount" and "umount" into the new tool fzfs.
Franz Glasner <fzglas.hg@dom66.de>
parents: 265
diff changeset
570 exec "$(dirname $0)/fzfs" mount "$@"
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
571 ;;
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
572 umount|unmount)
276
3c24b07240f2 Move the implementation of "mount" and "umount" into the new tool fzfs.
Franz Glasner <fzglas.hg@dom66.de>
parents: 265
diff changeset
573 exec "$(dirname $0)/fzfs" umount "$@"
194
379d3178f3ce mount and umount support for ZFS datasets: recursively mount and unmount
Franz Glasner <fzglas.hg@dom66.de>
parents: 193
diff changeset
574 ;;
73
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
575 privs)
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
576 command_privs "$@"
2e991a00035b Creation of Jail datasets done
Franz Glasner <hg@dom66.de>
parents: 72
diff changeset
577 ;;
76
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
578 populate)
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
579 command_populate "$@"
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
580 ;;
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
581 configure)
220
9addf133d208 FIX: Typo when calling the internal implementation of "configure"
Franz Glasner <f.glasner@feldmann-mg.com>
parents: 219
diff changeset
582 command_configure "$@"
219
39b736a91d0d Begin a "configure" command for jails
Franz Glasner <fzglas.hg@dom66.de>
parents: 211
diff changeset
583 ;;
226
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
584 hostid)
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
585 command_hostid "$@"
73f2436fdf86 Make "hostid" a separate command for printint hostid proposals
Franz Glasner <fzglas.hg@dom66.de>
parents: 225
diff changeset
586 ;;
77
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
587 copy)
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
588 command_copy "$@"
5aab3a28895f Implemented a "copy" command to employ zfs send/receive for recursively copying jail datasets
Franz Glasner <hg@dom66.de>
parents: 76
diff changeset
589 ;;
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
590 *)
76
fea2ef3ff89a Populate an existing directory tree with the contents of base.txz
Franz Glasner <hg@dom66.de>
parents: 75
diff changeset
591 echo "ERROR: unknown command \`${command}'" >&2
72
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
592 exit 2
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
593 ;;
929051be7845 Begin a simple (ZFS-related) jail setup tool
Franz Glasner <fzglas.hg@dom66.de>
parents:
diff changeset
594 esac